
# Ȗڂ̏Wv}X^
class AccountTitleTreesController < ApplicationController
  # GET /account_title_trees
  # GET /account_title_trees.xml
  def index
    @account_title_trees = AccountTitleTree.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @account_title_trees }
    end
  end

  # GET /account_title_trees/1
  # GET /account_title_trees/1.xml
  def show
    @account_title_tree = AccountTitleTree.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @account_title_tree }
    end
  end

  # GET /account_title_trees/new
  # GET /account_title_trees/new.xml
  def new
    @account_title_tree = AccountTitleTree.new
    @parent_cand = AccountTitle.find :all,
                 :conditions => '(end_day IS NULL) AND aggregate_flag IS TRUE',
                 :order => 'account_code, suppl_code'
    @child_cand = AccountTitle.find :all,
                 :conditions => '(end_day IS NULL)',
                 :order => 'account_code, suppl_code'

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @account_title_tree }
    end
  end

  # GET /account_title_trees/1/edit
  def edit
    @account_title_tree = AccountTitleTree.find(params[:id])
  end

  # POST /account_title_trees
  # POST /account_title_trees.xml
  def create
    v = params[:account_title_tree]
    AccountTitleTree.transaction {
      v[:child_id].each {|c|
        @account_title_tree = AccountTitleTree.new :parent_id => v[:parent_id],
                                                   :child_id => c
        @account_title_tree.save!
      }
    }
    respond_to do |format|
      flash[:notice] = 'AccountTitleTree was successfully created.'
      format.html { redirect_to(@account_title_tree) }
      format.xml  { render :xml => @account_title_tree, :status => :created, :location => @account_title_tree }
=begin      
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @account_title_tree.errors, :status => :unprocessable_entity }
      end
=end
    end
  end

  # PUT /account_title_trees/1
  # PUT /account_title_trees/1.xml
  def update
    @account_title_tree = AccountTitleTree.find(params[:id])

    respond_to do |format|
      if @account_title_tree.update_attributes(params[:account_title_tree])
        flash[:notice] = 'AccountTitleTree was successfully updated.'
        format.html { redirect_to(@account_title_tree) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @account_title_tree.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /account_title_trees/1
  # DELETE /account_title_trees/1.xml
  def destroy
    @account_title_tree = AccountTitleTree.find(params[:id])
    @account_title_tree.destroy

    respond_to do |format|
      format.html { redirect_to(account_title_trees_url) }
      format.xml  { head :ok }
    end
  end
end
